//-----------------------------------------------------------------------------
//                            CarthaGene
//
// Martin Bouchez, Patrick Chabrier, Christine Gaspin and Thomas Schiex. 
// Unite de Biometrie et Intelligence Artificielle, Toulouse, France
//
// Copyright 1997 INRA (Institut National de la Recherche Agronomique).
// This file is distributed under the terms of the Q Public License version 1.0.
// 
// $Id: neotest.cc,v 1.8 2004/06/18 07:44:46 tschiex Exp $
//
// Description : Programme principal.
// Divers : test
//-----------------------------------------------------------------------------

#include "CartaGene.h"
#include "Carte.h"

#include <stdio.h>
#include <string.h>
#include <iostream>
#include <sys/stat.h>

char bouf[1024];
char boufi[1024];
FILE *Fout;

int main(int argc, char *argv[])
{

  struct stat buf;
  int nm;
  int *vm;
  Carte *LaCarte;
  double thecost;


  int DFsize = 5;
  double DFthres = 3.0;
  int DFiter = 0;

  /* pour le recuit */

  int Tries = 50;
  double Tinit = 100;
  double Tfinal = 0.1;
  double Cooling = 0.5;

  /* pour le glouton*/

  int NbRun = 1;
  int NbIter = 0;
  int TabooLenMin = 5;
  int TabooLenMax = 25;

  /* pour algorithmes gntiques */

  int NbGens = 10;
  int NbEle = 10;
  int SelNbr = 0;
  float pCross = 0.33;
  float pMut = 0.55;
  int EvolFitness = 1;

  CartaGene Cartage;
  
  int i,j;

  for (i = 1; i < argc; i++) 
    {
      if (stat(argv[i], &buf) == -1) 
	{
	  printf("%s: fichier inexistant\n", argv[i]);
	  perror(argv[i]);
	  return -1;
	}
      
      printf("Loaded : %s\n\n", Cartage.CharJeu(argv[i]));
      //Cartage.AffMarq();
      //Cartage.AffJeu();
      //Cartage.PrintTwoPointsLOD();      
    }
  
  // printf("Created : %s\n\n", Cartage.MerGen(1,2));
  //  printf("Created : %s\n", Cartage.MergOr(1,2));
  //printf("Created : %s\n\n", Cartage.MergOr(3,4));
  //printf("%s\n", Cartage.MergOr(5,6));

  //  Cartage.AffMarq();
  //  Cartage.AffJeu();
  //  Cartage.BuildFW(3.0,3.0,NULL,0,0);
  //Cartage.DumpEch(1);
  //Cartage.DumpEch(2);
  //Cartage.DumpEch(3);
  //Cartage.DumpEch(4);
  //Cartage.DumpEch(5);
  // Cartage.DumpEch(6);
  // Cartage.DumpEch(7);

  //Cartage.DumpTwoPointsLOD(1);
  // Cartage.DumpTwoPointsFR(1);
//   Cartage.DumpTwoPointsFR(2);
//   Cartage.DumpTwoPointsFR(3);
//   Cartage.DumpTwoPointsLOD(1);
//   Cartage.DumpTwoPointsLOD(2);
//   Cartage.DumpTwoPointsLOD(3);
  //Cartage.DumpTwoPointsLOD(2);
  //Cartage.DumpTwoPointsLOD(3);
  //Cartage.DumpTwoPointsLOD(4);
  //Cartage.DumpTwoPointsLOD(5);
  //  Cartage.DumpTwoPointsLOD(6);
  //  Cartage.DumpTwoPointsLOD(7);

  //  Cartage.Groupe(0.5, 3.0);
  //Cartage.Groupe(2, 0.5, 3.0);
  //Cartage.Groupe(3, 0.5, 3.0);

  //Cartage.Groupe(3, 0.5, 3.0);
  

  //  int *vmi;

  //  int nbm = Cartage.GetGroupeI(20, &vmi);

  // Cartage.ChangeSel(vmi, nbm);

  //   for (i = 0; i < nbm; i++)
  //   {
//       printf("%d\n", vmi[i]);
//       fflush(stdout);
//     }

 //    nm = 12;
//     vm = new int[nm];
//     for (i = 0; i < nm; i++) vm[i] = i + 1;

//    vm[2] = 14;

     //     Cartage.Heap.Print();

//    LaCarte = new Carte(&Cartage, nm, vm);

//    LaCarte->PrintMap();
  
//    thecost = Cartage.ComputeEM(LaCarte); 

//    LaCarte->PrintMap();

//    Cartage.PrintMap(LaCarte);
//    Cartage.PrintDMap(LaCarte);
  
//  Cartage.VerboseFlag = 2;
//  Cartage.QuietFlag = 0;
  //Cartage.BuildNiceMap();
  //Cartage.Heap.PrintDSort();
  // Cartage.Heap.Print();
  //  for (i=0;i<1000;i++)
  Cartage.SinglEM();
  // Cartage.Heap.PrintDSort();
  //Cartage.Heap.Print();
  // Cartage.Heap.PrintSort();

  // LaCarte = Cartage.Heap.Best();

  char *** roro = Cartage.GetMap("k",0);
  i = 0;
  while (roro[i] != NULL) {
    j = 0;
    while (roro[i][j] != NULL)
      {
	printf("%s\n", roro[i][j]);
	delete [] roro[i][j++];
      }
    delete [] roro[i++];
  }
  
    //   Cartage.Annealing(Tries, Tinit, Tfinal, Cooling);

//   Cartage.Heap.PrintDSort();

//   Cartage.ResizeHeap(3);

//   Cartage.Heap.PrintDSort();

 //    Cartage.ChangeSel(vm, nm);

//     Cartage.ChangeSel(vm, nm);

//     Cartage.Build(1);

//     Cartage.Heap.PrintDSort();

  //   Cartage.SinglEM();
  
//   Cartage.Heap.PrintDSort();

   
  //   Cartage.Annealing(Tries, Tinit, Tfinal, Cooling);
   Cartage.Greedy(NbRun, NbIter,TabooLenMin, TabooLenMax,0);
    //    Cartage.AlgoGen(NbGens, NbEle, SelNbr, pCross,
    //	    pMut, EvolFitness);
   Cartage.Heap.PrintDSort();

  //Cartage.Heap.PrintDSort();


//   Cartage.Heap.Print();

//   printf("+++++++++++++++++\n");

//   Cartage.Heap.PrintSort();

//      Cartage.Flips(DFsize, DFthres, DFiter);
//      Cartage.Flips(5, 3.0, 1.0);
//      Cartage.Heap.PrintSort();

//      Cartage.Heap.Stat(1.0);

//   Cartage.Polish();

//   Cartage.Heap.PrintSort();

  //LaCarte->PrintDMap();
  //
 Carte *best;
best = Cartage.Heap.Best();
	Cartage.PrintDMap(best,0,best);
  //Cartage.PrintDMap(LaCarte);
  
  return 0;
}
