//-----------------------------------------------------------------------------
//                            CarthaGene
//
// Martin Bouchez, Patrick Chabrier, Christine Gaspin and Thomas Schiex. 
// Unite de Biometrie et Intelligence Artificielle, Toulouse, France
//
//  Copyright (C) 1997 INRA (Institut National de la Recherche Agronomique).
//
// $Id: cgsh.cc,v 1.47 2004/06/30 08:13:24 degivry Exp $
//
//    This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Module 	: cgsh
// Projet	: CartaGene
//
// Description : Implmentation de l'interface entre CartaGene 
// et le langage de script.
//
// Remarque : l'implmentation doit tre triviale. 
// C''est au niveau de la classe CartaGene que l'effort doit tre fait.
//
// A commenter librement...l'effort tant  faire dans cgsh.h et dans cgsh.i
//
//-----------------------------------------------------------------------------
//-INRA--------------------Station de Biomtrie et d''Intelligence Artificielle
//-----------------------------------------------------------------------------

#include "cgsh.h"
#include <string.h>
#include <stdio.h>
#include <signal.h>
#include "tcl.h"

CartaGene Cartage;

char  bouf[1024];
char boufi[1024];
FILE *Fout;

class BioJeu;

extern Tcl_Interp *linterp;

void hand(int sig)
{ 
  // enregistrement d'une demande d'arrt.
  if (sig == SIGINT) Cartage.StopFlag = 1;
  signal(SIGINT, hand);
}

void dsload(char help[3], char *fileName, char **textout)
{
  Cartage.StopFlag = 0;
  *textout = Cartage.CharJeu(fileName);
  fflush(stdout);
}

void dsmergen(char help[3], int SetID1, int SetID2, char **textout)
{
  Cartage.StopFlag = 0;
  *textout = Cartage.MerGen(SetID1, SetID2);
   fflush(stdout);
}

void dsmergor(char help[3], int SetID1, int SetID2, char **textout)
{
  Cartage.StopFlag = 0;
  *textout = Cartage.MergOr(SetID1, SetID2);
   fflush(stdout);
}

void dsinfo(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.AffJeu();
  fflush(stdout);
}

void dsget(char help[3], char ***ltextout)
{
  Cartage.StopFlag = 0;
  *ltextout = Cartage.GetArbre();
  fflush(stdout);
}

void mrkinfo(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.AffMarq();
  fflush(stdout);
}

void mrkselset(char help[3], int vm[NBM])
{

  int vmp[NBM];
  
  Cartage.StopFlag = 0;
  
  // dcompte du nombre de marqueurs

  int i = 0;

  while (vm[i]) 
    {
      vmp[i] = vm[i];
      i++;
    }

  Cartage.ChangeSel(vmp, i);
  fflush(stdout);
}

void mrkselget(char help[3], int **lmiout)
{
  Cartage.StopFlag = 0;
  Cartage.GetSel(lmiout);
  fflush(stdout);
}

void mrkallget(char help[3], int **lmiout)
{
  Cartage.StopFlag = 0;
  Cartage.GetAll(lmiout);
  fflush(stdout);
}

void mrklod2p(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.PrintTwoPointsLOD();
  fflush(stdout);
}

void mrkdouble(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.DumpDouble();
  fflush(stdout);
}

void mrkdist2p(char help[3], char UnitFlag[2])
{
  Cartage.StopFlag = 0;
  Cartage.PrintTwoPointsDist(UnitFlag);
  fflush(stdout);
}

void mrkfr2p(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.PrintTwoPointsFR();
  fflush(stdout);
}

void mrkmerge(char help[3], int MrkID1, int MrkID2)
{
  Cartage.StopFlag = 0;
  Cartage.Merge(MrkID1,MrkID2);
  fflush(stdout);
}

void mrkmerget(char help[3], char ***ltextout)
{
  Cartage.StopFlag = 0;
  *ltextout = Cartage.GetMerged();
  fflush(stdout);
}

void mrkname(char help[3], int MrkID, char **textout)
{
  Cartage.StopFlag = 0;
  *textout = Cartage.GetMrkName(MrkID);
  fflush(stdout);
}

int mrkid(char help[3], char *MrkName)
{
  Cartage.StopFlag = 0;
  int temp = Cartage.GetMrkId(MrkName);
  fflush(stdout);
  return temp;
}

int mrklast(char help[3])
{
  Cartage.StopFlag = 0;
  int temp = Cartage.LastMrk();
  fflush(stdout);
  return temp;
}

void verbset(char help[3], int flag)
{
  Cartage.StopFlag = 0;
  Cartage.SetVerbose(flag);
  fflush(stdout);
}

void quietset(char help[3], int flag)
{
  Cartage.StopFlag = 0;
  Cartage.SetQuiet(flag);
  fflush(stdout);
}

void sem(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.SinglEM();
  fflush(stdout);
}

void nicemapd(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.BuildNiceMap();
  fflush(stdout);
}

void nicemapl(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.BuildNiceMapL();
  fflush(stdout);
}

void mfmapd(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.BuildNiceMapMultiFragment();
  fflush(stdout);
}

void mfmapl(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.BuildNiceMapLMultiFragment();
  fflush(stdout);
}

void build(char help[3],
	   int NC)
{
  Cartage.StopFlag = 0;
  Cartage.Build(NC);
  fflush(stdout);
}

void buildfw(char help[3],
	     double KeepThres, 
	     double AddThres,
	     int vm[NBM],
	     int DM)
{
  int vmp[NBM];
  
  Cartage.StopFlag = 0;

  // dcompte du nombre de marqueurs
  
  int i = 0;
  
  while (vm[i]) 
    {
      vmp[i] = vm[i];
      i++;
    }
  
  Cartage.BuildFW(KeepThres, AddThres, vmp, i, DM);
  fflush(stdout);
}

void annealing(char help[3],
	       int Tries,
	       double Tinit,
	       double Tfinal,
	       double Cooling)
{
  Cartage.StopFlag = 0;
  Cartage.Annealing(Tries, Tinit, Tfinal, Cooling);
  fflush(stdout);
}

void greedy(char help[3],
	    int NR, 
	    int NI,
	    int TMin, 
	    int TMax,
	    int Ratio)
{
  Cartage.StopFlag = 0;
  Cartage.Greedy(NR, NI, TMin, TMax, Ratio);
  fflush(stdout);
}

void algogen( char help[3],
	      int nb_gens,
	      int nb_elements,
	      int selection_number,
	      float pcross,
	      float pmut,
	      int evolutive_fitness)
{
  Cartage.StopFlag = 0;
  Cartage.AlgoGen(nb_gens,
		  nb_elements,
		  selection_number,
		  pcross,
		  pmut,
		  evolutive_fitness);
  fflush(stdout);
}

void cg2tsp(char help[3], char *fileName)
{
  Cartage.StopFlag = 0;
  Cartage.cg2tsp(fileName);
  fflush(stdout);
}

void lkh(char help[3], int nbrun, int backtrack)
{
  Cartage.StopFlag = 0;
  Cartage.lkh(nbrun,backtrack,contribLogLike2pt1,contribLogLike2pt2);
  fflush(stdout);
}

void ilkh(char help[3], int nbrun, int collectmaps, double threshold, int cost)
{
  Cartage.StopFlag = 0;
  Cartage.lkhiter(nbrun,collectmaps,threshold,cost,contribLogLike2pt1,contribLogLike2pt2);
  fflush(stdout);
}

void lkhn(char help[3], int nbrun, int backtrack)
{
  Cartage.StopFlag = 0;
  Cartage.lkh(nbrun,backtrack,normContribLogLike2pt1,normContribLogLike2pt2);
  fflush(stdout);
}

void ilkhn(char help[3], int nbrun, int collectmaps, double threshold, int cost)
{
  Cartage.StopFlag = 0;
  Cartage.lkhiter(nbrun,collectmaps,threshold,cost,normContribLogLike2pt1,normContribLogLike2pt2);
  fflush(stdout);
}

void lkhd(char help[3], int nbrun, int backtrack)
{
  Cartage.StopFlag = 0;
  Cartage.lkh(nbrun,backtrack,contribZero,contribHaldane);
  fflush(stdout);
}

void ilkhd(char help[3], int nbrun, int collectmaps, double threshold, int cost)
{
  Cartage.StopFlag = 0;
  Cartage.lkhiter(nbrun,collectmaps,threshold,cost,contribZero,contribHaldane);
  fflush(stdout);
}

void lkhl(char help[3], int nbrun, int backtrack)
{
  Cartage.StopFlag = 0;
  Cartage.lkh(nbrun,backtrack,contribZero,contribLOD);
  fflush(stdout);
}

void ilkhl(char help[3], int nbrun, int collectmaps, double threshold, int cost)
{
  Cartage.StopFlag = 0;
  Cartage.lkhiter(nbrun,collectmaps,threshold,cost,contribZero,contribLOD);
  fflush(stdout);
}

void lkhocb(char help[3], int nbrun, int backtrack)
{
  Cartage.StopFlag = 0;
  Cartage.lkh(nbrun,backtrack,contribZero,contribOCB);
  fflush(stdout);
}

void ilkhocb(char help[3], int nbrun, int collectmaps, double threshold, int cost)
{
  Cartage.StopFlag = 0;
  Cartage.lkhiter(nbrun,collectmaps,threshold,cost,contribZero,contribOCB);
  fflush(stdout);
}

void lkhocbn(char help[3], int nbrun, int backtrack)
{
  Cartage.StopFlag = 0;
  Cartage.lkh(nbrun,backtrack,contribZero,normContribOCB);
  fflush(stdout);
}

void ilkhocbn(char help[3], int nbrun, int collectmaps, double threshold, int cost)
{
  Cartage.StopFlag = 0;
  Cartage.lkhiter(nbrun,collectmaps,threshold,cost,contribZero,normContribOCB);
  fflush(stdout);
}

int mapocb(char help[3], int MapID)
{
  Cartage.StopFlag = 0;
  int res = Cartage.OCB(MapID);
  fflush(stdout);
  return res;
}

void polish(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.Polish();
  fflush(stdout);
}

void polishtest(char help[3], int vm[NBM])	 
{	 
  
  int vmp[NBM];	 
  
  Cartage.StopFlag = 0;	 
  
  // dcompte du nombre de marqueurs	 
  
  int i = 0;	 
  
  while (vm[i]) 	 
    {	 
      vmp[i] = vm[i];	 
      i++;	 
    }	 
  Cartage.Polishtest(vmp, i);	 
  fflush(stdout);	 
}

void flips(char help[3], int ws, double Thres, int Fiter)
{
  Cartage.StopFlag = 0;
  Cartage.Flips(ws, Thres, Fiter);
  fflush(stdout);
}

void heapequiset(char help[3], int flag)
{
  Cartage.StopFlag = 0;
  Cartage.Heap.Equi(flag);
  Cartage.ResizeHeap(Cartage.Heap.HeapSize);
  fflush(stdout);
}

void heapsize(char help[3], int hs)
{
  Cartage.StopFlag = 0;
  Cartage.ResizeHeap(hs);
  fflush(stdout);
}

int heapsizeget(char help[3])
{
  Cartage.StopFlag = 0;
  int temp = Cartage.Heap.MaxHeapSize;
  fflush(stdout);
  return temp;
}

void heaprinto(char help[3], int NbMrk, int Blank, int Comp)
{
  Cartage.StopFlag = 0;
  Cartage.Heap.PrintO(NbMrk, Blank, Comp);
  fflush(stdout);
}

void heaprint(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.Heap.PrintSort();
  fflush(stdout);
}

void heaprintd(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.Heap.PrintDSort();
  fflush(stdout);
}

void heapget(char help[3], char UnitFlag[2], int NbMap, char *****llmapout)
{
  Cartage.StopFlag = 0;
  *llmapout = Cartage.GetHeap(UnitFlag, NbMap);
  fflush(stdout);
}

void maprint(char help[3], int MapID)
{
  Cartage.StopFlag = 0;
  Cartage.PrintMap(MapID);
  fflush(stdout);
}

void maprintd(char help[3], int MapID)
{
  Cartage.StopFlag = 0;
  Cartage.PrintDMap(MapID, 0);
  fflush(stdout);
}

void maprintdr(char help[3], int MapID)
{
  Cartage.StopFlag = 0;
  Cartage.PrintDMap(MapID, 1);
  fflush(stdout);
}


void mapget(char help[3], char UnitFlag[2], int MapID, char ****lmapout)
{
  Cartage.StopFlag = 0;
  *lmapout = Cartage.GetMap(UnitFlag, MapID);
  fflush(stdout);
}

void mapordget(char help[3], int MapID, int **lmiout)
{
  Cartage.StopFlag = 0;
  Cartage.GetOrdMap(MapID, lmiout);
  fflush(stdout);
}

int group(char help[3], double DistThres, double LODThres)
{
  Cartage.StopFlag = 0;
  int temp = Cartage.Groupe(DistThres, LODThres);
  fflush(stdout);
  return temp;
}

void groupget(char help[3], int GrID, int **lmiout)
{
  Cartage.StopFlag = 0;
  Cartage.GetGroupeI(GrID, lmiout);
  fflush(stdout);
}

void cgout(char help[3], char *fileName)
{
  Cartage.StopFlag = 0;
  Cartage.Tracer(fileName);
  fflush(stdout);
}

void cgtolerance(char help[3], double Threshold1, double Threshold2)
{
  Cartage.SetTolerance(Threshold1,Threshold2);
  fflush(stdout);
}

void cgrobustness(char help[3], double Threshold)
{
  Cartage.SetRobustness(Threshold);
  fflush(stdout);
}

void cgnotrobust(char help[3])
{
  Cartage.SetRobustness(1e100);
  Cartage.StopFlag = 0;
  fflush(stdout);
}

void cgversion(char help[3])
{
  Cartage.StopFlag = 0;
  signal(SIGINT, hand);
  Cartage.Version();
  fflush(stdout);
}

void cgstat(char help[3], double LODThres, char **textout)
{
  Cartage.StopFlag = 0;
  *textout = Cartage.Heap.Stat(LODThres);
  fflush(stdout);
}

void cgrestart(char help[3])
{
  Cartage.StopFlag = 0;
  Cartage.Clear();
  fflush(stdout);
}

void cglicense(char help[3], char *Key)
{

  Cartage.StopFlag = 0;  
  signal(SIGINT, hand);
  Cartage.License(Key);
  fflush(stdout);
}

void cgstop(char help[3])
{ 
  Cartage.StopFlag = 0;
  raise(SIGINT);
  fflush(stdout);
}
